program compute_pi

! times using dtime
real, dimension(2) :: tarray

! times using system_clock
integer sccb,scce,sccr,sccm
real(kind=8) sccd,scdiff

integer i
integer, parameter        :: n=10000000
real(kind=8) w,x,sum,pi,f,a,sum0

! function to integrate
f(a)=4.0_8/(1.0_8+a*a)

t0=dtime(tarray)

call system_clock(count=sccb,count_rate=sccr,count_max=sccm)

! calculate the interval size
w=1.0_8/n
sum=0.0_8

!$OMP PARALLEL PRIVATE(x,sum0), SHARED(w,sum)
sum0=sum
!$OMP DO
do i=1,n
   x=w*(i-0.5_8)
   sum0=sum0+f(x)
enddo
!$OMP END DO
!$OMP CRITICAL
   sum=sum+sum0
!$OMP END CRITICAL
!$OMP END PARALLEL
pi=w*sum

t1=dtime(tarray)

call system_clock(count=scce,count_rate=sccr,count_max=sccm)
sccd=scdiff(sccb,scce,sccr,sccm)
write (*,'(/,a,1pg24.16)')   'computed pi = ', pi
write (*,'(2(/,a,1pg12.4))') 'dtime user time:   ', tarray(1), &
                             'dtime system time: ', tarray(2)
write (*,'(/,a,1pg12.4,a)')  'system clock time: ',sccd,' seconds'

stop
end program compute_pi
