	program compute_pi
	integer n,i
	double precision w,x,sum,pi,f,a
	parameter (n=10 000 000)
! times using dtime
	real tarray(2)
! times using system_clock
	integer sccb,scce,sccr,sccm
	double precision sccd,scdiff
c function to integrate
	f(a)=4.d0/(1.d0+a*a)
c
        t0=dtime(tarray)
	call system_clock(count=sccb,count_rate=sccr,count_max=sccm)
c calculate the interval size
	w=1.0d0/n
	sum=0.0d0
!$OMP PARALLEL PRIVATE(x), SHARED(w,sum)
!$OMP DO REDUCTION(+: sum)
	do i=1,n
	  x=w*(i-0.5d0)
	  sum=sum+f(x)
	enddo
!$OMP END DO
!$OMP END PARALLEL
	pi=w*sum
c
        t1=dtime(tarray)
	call system_clock(count=scce,count_rate=sccr,count_max=sccm)
	sccd=scdiff(sccb,scce,sccr,sccm)
	write (*,'(/,a,1pg24.16)') 'computed pi = ', pi
	write (*,'(2(/,a,1pg12.4))')
     f	'dtime user time  :', tarray(1),
     f	'dtime system time:', tarray(2)
	write (*,'(/,a,1pg12.4,a)')
     f	'system clock time: ',sccd,' seconds'
	stop
	end
